<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_CategoriaHabitacionMast.xml */
/* Generado: 2020-08-18 04:21:27 */

/* Mantenimiento de los registros de la tabla MST_CategoriaHabitacionMast */
abstract class BaseMST_CategoriaHabitacionMastDP extends MST_CategoriaHabitacionMastBV
{
    /* Constructor ( Establece los valores desde un objeto MST_CategoriaHabitacionMastBN ) */
    public function __construct( MST_CategoriaHabitacionMastBN $o_MST_CategoriaHabitacionMastBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_CategoriaHabitacionMastBN ) )
        {
            $this->setByBN( $o_MST_CategoriaHabitacionMastBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_CategoriaHabitacionMastBN */
    public function setByBN( MST_CategoriaHabitacionMastBN $o_MST_CategoriaHabitacionMastBN )
    {
        if ( !is_null( $o_MST_CategoriaHabitacionMastBN->getIdCategoria() ) )
        {
            $this->setIdCategoria( $o_MST_CategoriaHabitacionMastBN->getIdCategoria() );
        }
        if ( !is_null( $o_MST_CategoriaHabitacionMastBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_MST_CategoriaHabitacionMastBN->getIdCompania() );
        }
        if ( !is_null( $o_MST_CategoriaHabitacionMastBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_MST_CategoriaHabitacionMastBN->getIdSucursal() );
        }
        if ( !is_null( $o_MST_CategoriaHabitacionMastBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_MST_CategoriaHabitacionMastBN->getDescripcion() );
        }
        if ( !is_null( $o_MST_CategoriaHabitacionMastBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_CategoriaHabitacionMastBN->getEstado() );
        }
        if ( !is_null( $o_MST_CategoriaHabitacionMastBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_CategoriaHabitacionMastBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_CategoriaHabitacionMastBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_CategoriaHabitacionMastBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_CategoriaHabitacionMastBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_CategoriaHabitacionMastBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_CategoriaHabitacionMastBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_CategoriaHabitacionMastBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_CategoriaHabitacionMastFN = new MST_CategoriaHabitacionMastFN();
        $o_MST_CategoriaHabitacionMastBN = $o_MST_CategoriaHabitacionMastFN->selectByPk( $this->getIdCategoria() );
        if ( is_null( $o_MST_CategoriaHabitacionMastBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_CategoriaHabitacionMast ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCategoria() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCategoria";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCategoria()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_CategoriaHabitacionMast SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdCategoria = ".$this->getIdCategoria().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_CategoriaHabitacionMast WHERE  IdCategoria = ".$this->getIdCategoria().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>